package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.model.CdmSessionDataRepository;

/**
 * Commit any changes to this taxon to the CDM
 * 
 * @author p.ciardelli
 *
 */
public class SaveTaxonAction extends Action {
	private static final Logger logger = Logger.getLogger(SaveTaxonAction.class);
	
	private Taxon taxon;
	
	public SaveTaxonAction(Taxon taxon) {
		this.taxon = taxon;
	}
	
	public void run() {
		
		// Save the taxon to the CDM
		CdmSessionDataRepository.getDefault().saveTaxon(taxon);
	}
}