/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.ui;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.controller.EditorController;

/**
 * Opens a taxon editor for an existing or new taxon.
 * 
 * @author p.ciardelli
 * @created 02.06.2008
 * @version 1.0
 */
public class OpenTaxonEditorAction extends Action implements IWorkbenchWindowActionDelegate {
	private static final Logger logger = Logger
			.getLogger(OpenTaxonEditorAction.class);

	private static String editTaxonText = "Edit taxon";
	private static String newTaxonText = "Add new taxon";
//	private ImageDescriptor image = TaxEditorPlugin.getDefault()
//			.getImageDescriptor(ITaxEditorConstants.OPEN_TAXON_ICON);
	private ImageDescriptor image = null;
	
	private IWorkbenchWindow window;
	
	private Taxon taxon;
	public static final String ID = "eu.etaxonomy.taxeditor.actions.opennameeditoraction"; //$NON-NLS-1$
	
	public OpenTaxonEditorAction(Taxon taxon) {
		this();
		
		this.taxon = taxon;
		if (taxon != null) {
			setText(editTaxonText);
		}
	}

	public OpenTaxonEditorAction() {
		super(newTaxonText);
		setImageDescriptor(image);
		setId(ID);
	}
	
	@Override
	public void run() {
		
    	EditorController.open(taxon);
		
		// For clients who re-use the same instance of this class, 
		//	taxon is re-initalized to ensure a new Taxon is opened every time
		taxon = null;
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}

	@Override
	public void run(IAction action) {
		run();
	}

	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub
		
	}
}