/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.reference;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import eu.etaxonomy.cdm.model.reference.ReferenceBase;

/**  
 * @author p.ciardelli
 * @created 19.05.2008
 * @version 1.0
 */
abstract public class ReferenceSearchDescriptor extends PropertyDescriptor {
	private static final Logger logger = Logger
			.getLogger(ReferenceSearchDescriptor.class);
		
	int searchType;
	
	public ReferenceSearchDescriptor(Object id, String displayName, int searchType) {
		super(id, displayName);
		
		this.searchType = searchType;
	}

    public CellEditor createPropertyEditor(Composite parent) {
        CellEditor editor = new DialogCellEditor(parent) {

			protected Object openDialogBox(
					Control cellEditorWindow) {
		        Dialog dialog = new ReferenceSearchDialog(cellEditorWindow.getShell(), 
		        		searchType);
		        Object value = ((ReferenceSearchDialog) dialog).open();
				if (value instanceof ReferenceBase) {
					
					ReferenceBase reference = (ReferenceBase) value;
					saveReference(reference);
					return new ReferencePropertySource(reference);
				}
				return null;
			}
        };
        if (getValidator() != null) {
			editor.setValidator(getValidator());
		}
        return editor;
    }
        
    abstract protected void saveReference(ReferenceBase reference);	
}
